define(['jquery',
    'mage/template',
    'jquery/ui',
    'prototype',
    'Magento_VisualMerchandiser/js/tabs',
    'Magento_VisualMerchandiser/js/add_products',
    'jquery_multisortable',
    'Magento_VisualMerchandiser/js/merchandiser'
], function ($, mageTemplate) {
        'use strict';

        $.widget('filoblu.merchandiser', $.mage.visualMerchandiser, {

        setupTileView: function () {
            var sortableParent = this.tileView.find('#catalog_category_merchandiser_list'),
                    data;

            sortableParent.multisortable({
                click: this.multiSortableStartUpdate.bind(this),
                stop: this.sortableDidUpdate.bind(this)

            });

            data = {};
            sortableParent.data('sortable').items.each(function (instance) {
                var key = $(instance.item).find('input[name=entity_id]').val();

                data[key] = $(instance.item);
            });

            sortableParent.data('item_id_mapper', data);
        },

        /**
         * Store the original index
         *
         * @param {Event} event
         * @param {Object} ui
         */
        multiSortableStartUpdate: function (event, item) {
            $("input[name=position]", item).focus().select();
            item.data('originIndex', item.index());
        }

        });

        return $.filoblu.merchandiser;
});